searchNodes=[{"ref":"ResxBase.html","title":"ResxBase","type":"module","doc":""},{"ref":"ResxBase.html#decode16_lower/3","title":"ResxBase.decode16_lower/3","type":"function","doc":"Decodes encoded strings produced by the encode16_lower/3 function. By default the decoded data will be stripped of any bits that do not fit in the byte boundaries. This behaviour can be changed by setting the :bits option to true. The resulting bitstring may contain some pad bits. If the encoded string contains some padding characters these will to be specified so they can be removed. Set the :pad_chr option to the padding sequence that was used when encoding this data. Multiple encoded strings with the same padding sequence can be chained together, and will be decoded into a contiguous set of data.iex&gt; ResxBase.decode16_lower(&quot;0&quot;) { :ok, &quot;&quot; } iex&gt; ResxBase.decode16_lower(&quot;0&quot;, bits: true) { :ok, &lt;&lt;0::size(4)&gt;&gt; } iex&gt; ResxBase.decode16_lower(&quot;0\\a&quot;, bits: true, pad_chr: &quot;\\a&quot;) { :ok, &lt;&lt;0::size(4)&gt;&gt; } iex&gt; ResxBase.decode16_lower(&quot;0000&quot;, bits: true) { :ok, &lt;&lt;0, 0&gt;&gt; }"},{"ref":"ResxBase.html#decode16_upper/3","title":"ResxBase.decode16_upper/3","type":"function","doc":"Decodes encoded strings produced by the encode16_upper/3 function. By default the decoded data will be stripped of any bits that do not fit in the byte boundaries. This behaviour can be changed by setting the :bits option to true. The resulting bitstring may contain some pad bits. If the encoded string contains some padding characters these will to be specified so they can be removed. Set the :pad_chr option to the padding sequence that was used when encoding this data. Multiple encoded strings with the same padding sequence can be chained together, and will be decoded into a contiguous set of data.iex&gt; ResxBase.decode16_upper(&quot;0&quot;) { :ok, &quot;&quot; } iex&gt; ResxBase.decode16_upper(&quot;0&quot;, bits: true) { :ok, &lt;&lt;0::size(4)&gt;&gt; } iex&gt; ResxBase.decode16_upper(&quot;0\\a&quot;, bits: true, pad_chr: &quot;\\a&quot;) { :ok, &lt;&lt;0::size(4)&gt;&gt; } iex&gt; ResxBase.decode16_upper(&quot;0000&quot;, bits: true) { :ok, &lt;&lt;0, 0&gt;&gt; }"},{"ref":"ResxBase.html#decode32/3","title":"ResxBase.decode32/3","type":"function","doc":"Decodes encoded strings produced by the encode32/3 function. By default the decoded data will be stripped of any bits that do not fit in the byte boundaries. This behaviour can be changed by setting the :bits option to true. The resulting bitstring may contain some pad bits. If the encoded string contains some padding characters these will to be specified so they can be removed. Set the :pad_chr option to the padding sequence that was used when encoding this data. Multiple encoded strings with the same padding sequence can be chained together, and will be decoded into a contiguous set of data.iex&gt; ResxBase.decode32(&quot;A&quot;) { :ok, &quot;&quot; } iex&gt; ResxBase.decode32(&quot;A&quot;, bits: true) { :ok, &lt;&lt;0::size(5)&gt;&gt; } iex&gt; ResxBase.decode32(&quot;A\\a\\a\\a\\a\\a\\a\\a&quot;, bits: true, pad_chr: &quot;\\a&quot;) { :ok, &lt;&lt;0::size(5)&gt;&gt; } iex&gt; ResxBase.decode32(&quot;AAAA&quot;, bits: true) { :ok, &lt;&lt;0, 0, 0::size(4)&gt;&gt; }"},{"ref":"ResxBase.html#decode64/3","title":"ResxBase.decode64/3","type":"function","doc":"Decodes encoded strings produced by the encode64/3 function. By default the decoded data will be stripped of any bits that do not fit in the byte boundaries. This behaviour can be changed by setting the :bits option to true. The resulting bitstring may contain some pad bits. If the encoded string contains some padding characters these will to be specified so they can be removed. Set the :pad_chr option to the padding sequence that was used when encoding this data. Multiple encoded strings with the same padding sequence can be chained together, and will be decoded into a contiguous set of data.iex&gt; ResxBase.decode64(&quot;A&quot;) { :ok, &quot;&quot; } iex&gt; ResxBase.decode64(&quot;A&quot;, bits: true) { :ok, &lt;&lt;0::size(6)&gt;&gt; } iex&gt; ResxBase.decode64(&quot;A\\a\\a\\a&quot;, bits: true, pad_chr: &quot;\\a&quot;) { :ok, &lt;&lt;0::size(6)&gt;&gt; } iex&gt; ResxBase.decode64(&quot;AAAA&quot;, bits: true) { :ok, &lt;&lt;0, 0, 0&gt;&gt; }"},{"ref":"ResxBase.html#encode16_lower/3","title":"ResxBase.encode16_lower/3","type":"function","doc":"Encodes data into a string which can be decoded using the decode16_lower/3 function. The encoded data will pad any bits needed to make the entire data fit within byte boundaries. By default this padding will be using 0 bits, however this can be changed by setting the option :pad_bit to the specific bit sequence desired (note that only the part of the bit sequence needed to reach a byte boundary will be used). Optionally an encoded string can have additional padding put onto the final encoding (e.g. if you wanted to pack encodings together). To enable this behaviour set :multiple to the multiples of characters needed in the encoded string. e.g. A value of 1 (the default) will not require any padding, a value of 2 will require padding if there is only an odd number of characters. By default the encoded string padding will use 0 bytes, if a specific padding character(s) is desired, this can be done by setting the :pad_chr option to the string to use as the padding sequence (note that only the part of the character sequence needed to reach the specified multiple will be used).iex&gt; ResxBase.encode16_lower(&lt;&lt;0::size(4)&gt;&gt;) &quot;0&quot; iex&gt; ResxBase.encode16_lower(&lt;&lt;0::size(4)&gt;&gt;, multiple: 2, pad_chr: &quot;\\a&quot;) &quot;0\\a&quot; iex&gt; ResxBase.encode16_lower(&lt;&lt;0, 0&gt;&gt;) &quot;0000&quot;"},{"ref":"ResxBase.html#encode16_upper/3","title":"ResxBase.encode16_upper/3","type":"function","doc":"Encodes data into a string which can be decoded using the decode16_upper/3 function. The encoded data will pad any bits needed to make the entire data fit within byte boundaries. By default this padding will be using 0 bits, however this can be changed by setting the option :pad_bit to the specific bit sequence desired (note that only the part of the bit sequence needed to reach a byte boundary will be used). Optionally an encoded string can have additional padding put onto the final encoding (e.g. if you wanted to pack encodings together). To enable this behaviour set :multiple to the multiples of characters needed in the encoded string. e.g. A value of 1 (the default) will not require any padding, a value of 2 will require padding if there is only an odd number of characters. By default the encoded string padding will use 0 bytes, if a specific padding character(s) is desired, this can be done by setting the :pad_chr option to the string to use as the padding sequence (note that only the part of the character sequence needed to reach the specified multiple will be used).iex&gt; ResxBase.encode16_upper(&lt;&lt;0::size(4)&gt;&gt;) &quot;0&quot; iex&gt; ResxBase.encode16_upper(&lt;&lt;0::size(4)&gt;&gt;, multiple: 2, pad_chr: &quot;\\a&quot;) &quot;0\\a&quot; iex&gt; ResxBase.encode16_upper(&lt;&lt;0, 0&gt;&gt;) &quot;0000&quot;"},{"ref":"ResxBase.html#encode32/3","title":"ResxBase.encode32/3","type":"function","doc":"Encodes data into a string which can be decoded using the decode32/3 function. The encoded data will pad any bits needed to make the entire data fit within byte boundaries. By default this padding will be using 0 bits, however this can be changed by setting the option :pad_bit to the specific bit sequence desired (note that only the part of the bit sequence needed to reach a byte boundary will be used). Optionally an encoded string can have additional padding put onto the final encoding (e.g. if you wanted to pack encodings together). To enable this behaviour set :multiple to the multiples of characters needed in the encoded string. e.g. A value of 1 (the default) will not require any padding, a value of 2 will require padding if there is only an odd number of characters. By default the encoded string padding will use 0 bytes, if a specific padding character(s) is desired, this can be done by setting the :pad_chr option to the string to use as the padding sequence (note that only the part of the character sequence needed to reach the specified multiple will be used).iex&gt; ResxBase.encode32(&lt;&lt;0::size(5)&gt;&gt;) &quot;A&quot; iex&gt; ResxBase.encode32(&lt;&lt;0::size(5)&gt;&gt;, multiple: 8, pad_chr: &quot;\\a&quot;) &quot;A\\a\\a\\a\\a\\a\\a\\a&quot; iex&gt; ResxBase.encode32(&lt;&lt;0, 0, 0::size(4)&gt;&gt;) &quot;AAAA&quot;"},{"ref":"ResxBase.html#encode64/3","title":"ResxBase.encode64/3","type":"function","doc":"Encodes data into a string which can be decoded using the decode64/3 function. The encoded data will pad any bits needed to make the entire data fit within byte boundaries. By default this padding will be using 0 bits, however this can be changed by setting the option :pad_bit to the specific bit sequence desired (note that only the part of the bit sequence needed to reach a byte boundary will be used). Optionally an encoded string can have additional padding put onto the final encoding (e.g. if you wanted to pack encodings together). To enable this behaviour set :multiple to the multiples of characters needed in the encoded string. e.g. A value of 1 (the default) will not require any padding, a value of 2 will require padding if there is only an odd number of characters. By default the encoded string padding will use 0 bytes, if a specific padding character(s) is desired, this can be done by setting the :pad_chr option to the string to use as the padding sequence (note that only the part of the character sequence needed to reach the specified multiple will be used).iex&gt; ResxBase.encode64(&lt;&lt;0::size(6)&gt;&gt;) &quot;A&quot; iex&gt; ResxBase.encode64(&lt;&lt;0::size(6)&gt;&gt;, multiple: 4, pad_chr: &quot;\\a&quot;) &quot;A\\a\\a\\a&quot; iex&gt; ResxBase.encode64(&lt;&lt;0, 0, 0&gt;&gt;) &quot;AAAA&quot;"},{"ref":"ResxBase.html#hex_decode32/3","title":"ResxBase.hex_decode32/3","type":"function","doc":"Decodes encoded strings produced by the hex_encode32/3 function. By default the decoded data will be stripped of any bits that do not fit in the byte boundaries. This behaviour can be changed by setting the :bits option to true. The resulting bitstring may contain some pad bits. If the encoded string contains some padding characters these will to be specified so they can be removed. Set the :pad_chr option to the padding sequence that was used when encoding this data. Multiple encoded strings with the same padding sequence can be chained together, and will be decoded into a contiguous set of data.iex&gt; ResxBase.hex_decode32(&quot;0&quot;) { :ok, &quot;&quot; } iex&gt; ResxBase.hex_decode32(&quot;0&quot;, bits: true) { :ok, &lt;&lt;0::size(5)&gt;&gt; } iex&gt; ResxBase.hex_decode32(&quot;0\\a\\a\\a\\a\\a\\a\\a&quot;, bits: true, pad_chr: &quot;\\a&quot;) { :ok, &lt;&lt;0::size(5)&gt;&gt; } iex&gt; ResxBase.hex_decode32(&quot;0000&quot;, bits: true) { :ok, &lt;&lt;0, 0, 0::size(4)&gt;&gt; }"},{"ref":"ResxBase.html#hex_encode32/3","title":"ResxBase.hex_encode32/3","type":"function","doc":"Encodes data into a string which can be decoded using the hex_decode32/3 function. The encoded data will pad any bits needed to make the entire data fit within byte boundaries. By default this padding will be using 0 bits, however this can be changed by setting the option :pad_bit to the specific bit sequence desired (note that only the part of the bit sequence needed to reach a byte boundary will be used). Optionally an encoded string can have additional padding put onto the final encoding (e.g. if you wanted to pack encodings together). To enable this behaviour set :multiple to the multiples of characters needed in the encoded string. e.g. A value of 1 (the default) will not require any padding, a value of 2 will require padding if there is only an odd number of characters. By default the encoded string padding will use 0 bytes, if a specific padding character(s) is desired, this can be done by setting the :pad_chr option to the string to use as the padding sequence (note that only the part of the character sequence needed to reach the specified multiple will be used).iex&gt; ResxBase.hex_encode32(&lt;&lt;0::size(5)&gt;&gt;) &quot;0&quot; iex&gt; ResxBase.hex_encode32(&lt;&lt;0::size(5)&gt;&gt;, multiple: 8, pad_chr: &quot;\\a&quot;) &quot;0\\a\\a\\a\\a\\a\\a\\a&quot; iex&gt; ResxBase.hex_encode32(&lt;&lt;0, 0, 0::size(4)&gt;&gt;) &quot;0000&quot;"},{"ref":"ResxBase.html#url_decode64/3","title":"ResxBase.url_decode64/3","type":"function","doc":"Decodes encoded strings produced by the url_encode64/3 function. By default the decoded data will be stripped of any bits that do not fit in the byte boundaries. This behaviour can be changed by setting the :bits option to true. The resulting bitstring may contain some pad bits. If the encoded string contains some padding characters these will to be specified so they can be removed. Set the :pad_chr option to the padding sequence that was used when encoding this data. Multiple encoded strings with the same padding sequence can be chained together, and will be decoded into a contiguous set of data.iex&gt; ResxBase.url_decode64(&quot;A&quot;) { :ok, &quot;&quot; } iex&gt; ResxBase.url_decode64(&quot;A&quot;, bits: true) { :ok, &lt;&lt;0::size(6)&gt;&gt; } iex&gt; ResxBase.url_decode64(&quot;A\\a\\a\\a&quot;, bits: true, pad_chr: &quot;\\a&quot;) { :ok, &lt;&lt;0::size(6)&gt;&gt; } iex&gt; ResxBase.url_decode64(&quot;AAAA&quot;, bits: true) { :ok, &lt;&lt;0, 0, 0&gt;&gt; }"},{"ref":"ResxBase.html#url_encode64/3","title":"ResxBase.url_encode64/3","type":"function","doc":"Encodes data into a string which can be decoded using the url_decode64/3 function. The encoded data will pad any bits needed to make the entire data fit within byte boundaries. By default this padding will be using 0 bits, however this can be changed by setting the option :pad_bit to the specific bit sequence desired (note that only the part of the bit sequence needed to reach a byte boundary will be used). Optionally an encoded string can have additional padding put onto the final encoding (e.g. if you wanted to pack encodings together). To enable this behaviour set :multiple to the multiples of characters needed in the encoded string. e.g. A value of 1 (the default) will not require any padding, a value of 2 will require padding if there is only an odd number of characters. By default the encoded string padding will use 0 bytes, if a specific padding character(s) is desired, this can be done by setting the :pad_chr option to the string to use as the padding sequence (note that only the part of the character sequence needed to reach the specified multiple will be used).iex&gt; ResxBase.url_encode64(&lt;&lt;0::size(6)&gt;&gt;) &quot;A&quot; iex&gt; ResxBase.url_encode64(&lt;&lt;0::size(6)&gt;&gt;, multiple: 4, pad_chr: &quot;\\a&quot;) &quot;A\\a\\a\\a&quot; iex&gt; ResxBase.url_encode64(&lt;&lt;0, 0, 0&gt;&gt;) &quot;AAAA&quot;"},{"ref":"ResxBase.Decoder.html","title":"ResxBase.Decoder","type":"module","doc":"Decode data resources from a RFC 4648 encoding. Decoding The type of decoding is specified by using the :encoding option.Resx.Resource.transform(resource, ResxBase.Decoder, encoding: :base64) The list of available decoding formats to choose from are: :base16 - By default this works the same as Base.decode16/1. Optionally the case can be specified using the :case option, this can be either :lower (for lowercase input) or :upper (for uppercase input) or :mixed (for case-insensitive input).:base32 - By default this works the same as Base.encode32/1.:base64 - By default this works the same as Base.encode64/1.:hex32 - By default this works the same as Base.hex_encode32/1.:url64 - By default this works the same as Base.url_encode64/1. All decodings also take the configuration options specified in ResxBase. Streams Streamed data is expected to be made up of individual complete encoding sequences. Where each encoding is decoded as-is in the stream. e.g. If you had the encoded data &quot;aGVsbG8=IA==d29ybGQ=&quot; this would be decoded to: &quot;hello world&quot;. However if it was a stream consisting of [&quot;aGVsbG8=&quot;, &quot;IA==&quot;, &quot;d29ybGQ=&quot;], it would be decoded as: [&quot;hello&quot;, &quot; &quot;, &quot;world&quot;]."},{"ref":"ResxBase.Decoder.DecodingError.html","title":"ResxBase.Decoder.DecodingError","type":"exception","doc":""},{"ref":"ResxBase.Encoder.html","title":"ResxBase.Encoder","type":"module","doc":"Encode data resources into a RFC 4648 encoding. Encoding The type of encoding is specified by using the :encoding option.Resx.Resource.transform(resource, ResxBase.Encoder, encoding: :base64) The list of available encoding formats to choose from are: :base16 - By default this works the same as Base.encode16/1. Optionally the case can be specified using the :case option, this can be either :lower (for lowercase output) or :upper (for uppercase output).:base32 - By default this works the same as Base.encode32/1.:base64 - By default this works the same as Base.encode64/1.:hex32 - By default this works the same as Base.hex_encode32/1.:url64 - By default this works the same as Base.url_encode64/1. All encodings also take the configuration options specified in ResxBase. Streams Streams are encoded by forming a complete sequence and separating each encoded sequence with the necessary amount of padding characters. e.g. If you encoded &quot;hello world&quot; as a single base64 sequence you would end up with the encoded data: &quot;aGVsbG8gd29ybGQ=&quot;. However if it was a stream consisting of [&quot;hello&quot;, &quot; &quot;, &quot;world&quot;], it would be encoded as 3 individual sequences resulting in the encoded data: &quot;aGVsbG8=IA==d29ybGQ=&quot;"}]